# How to contribute

Thank you for reading this, we are always in need of volunteer developers to help this project remain strong.

## Testing

We require that all new submitted code be thoroughly tested. 

Code submitted without any unit testing will be rejected. To run the test coverage locally, run ```gradle jacocoReport``` and review the results in build/reports/jacoco

## Submitting changes

Please send a [GitHub Pull Request to MinesJTK/jtk](https://github.com/MinesJTK/jtk/pull/new/master) with a clear list of what you've done. 

## Coding conventions

Start reading our code and you'll get the hang of it. We optimize for readability:

  * We indent using two (2) spaces (soft tabs)
  * We always line break if the code exceeds 78 columns in width.
  * We document every public and protected method using official javadoc documentation.
  * We use standard camelCase nomenclature for methods and variables, no under_scoring.
  * This is open source software. Consider the people who will read your code and make it legible for them.
  
Thank you!
